

#include "mydatad.h"
#include "usart.h"
#include "stack.h"
#include <stdio.h>

    

//----------------------------------------------------------------------------
//Initialisierung des mydata Servers
void mydata_init (void)
{
  //Serverport und Anwendung eintragen
  add_tcp_app (MYDATAD_PORT, (void(*)(unsigned char))mydatad);
  usart_write("myDataD aktiv\r\n");
}


//----------------------------------------------------------------------------
//mydata Server daemon
void mydatad (U8 index){
  U16 a = 0;
  char c;

  //Verbindung wurde abgebaut
  if (tcp_entry[index].status & FIN_FLAG)
  {
    mydata.status.connected = 0;
    return;
  }

  //Verbindungsaufbau (erstes Paket)  
  if (tcp_entry[index].app_status == 0 || tcp_entry[index].app_status == 1)
  {
    tcp_entry[index].app_status = 1;
    tcp_entry[index].status =  ACK_FLAG;
    create_new_tcp_packet(0,index);
    mydata.status.ack_wait = 0;
    tcp_entry[index].time = TCP_TIME_OFF;
    mydata.status.connected = 1;
    return;
  }

  //Daten vom Ethernet mit gesetztem PUSH-Flag auf offenem Kanal
  if ((tcp_entry[index].app_status > 1) 
   && (tcp_entry[index].status & PSH_FLAG))
  {
    tcp_entry[index].app_status = 2;
	mydata.status.connected = 1;
    for(a=TCP_DATA_START_VAR; a < (TCP_DATA_END_VAR); a++){
      c = eth_buffer[a];
      usart_putc(c);
    }

    tcp_entry[index].status =  ACK_FLAG;
    create_new_tcp_packet(0, index);
    return;
  }
  
    
  //Ack erhalten (vom gesendeten Packet)
  if (    (tcp_entry[index].app_status > 1)
        &&(tcp_entry[index].status & ACK_FLAG)
        &&(mydata.status.ack_wait))
  {
    tcp_entry[index].time = TCP_TIME_OFF;
    mydata.tx_buffer_read = mydata.retransmission_ptr ;
    mydata.status.ack_wait = 0;
    return;
  }

  //Time out - kein ACK angekommen
  if (tcp_entry[index].status == 0) 
  {
    usart_write("mydatad: Daten nochmal senden\r\n"); //TODO: raus!

    //Daten nochmal senden
    mydata.status.ack_wait = 0;

    mydatad_send_data ();
    return;
  }
   
    
  return;
}




//----------------------------------------------------------------------------
void mydatad_send_data (void)
{
  U8 index;
  if (mydata.retransmission_ptr != mydata.tx_buffer_write )
  {
    for (index = 0;index<MAX_TCP_ENTRY;index++)
    {
      if(tcp_entry[index].dest_port == LBBL_ENDIAN_INT(MYDATAD_PORT))
      {
        if(!mydata.status.ack_wait)
        {
          mydata.status.ack_wait = 1;
          unsigned int count = 0;
          mydata.retransmission_ptr  = mydata.tx_buffer_read; 
          
          while(mydata.retransmission_ptr != mydata.tx_buffer_write  )
          {
            eth_buffer[TCP_DATA_START+count] = mydata.tx_buffer[mydata.retransmission_ptr++];
			mydata.retransmission_ptr &= (MYDATA_BUFFER_SIZE-1);
            count++;
          }
          tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
          create_new_tcp_packet(count,index);
          tcp_entry[index].time = TCP_MAX_ENTRY_TIME;
          return;
        }
        else
        {
          return;
        }
      }
    }
    
//    if (index >= MAX_TCP_ENTRY){
//      mydata.status.disabled = 0;
//    }
    
  }
}


//----------------------------------------------------------------------------
//Ausgabe eines Zeichens ber den Socket
//----------------------------------------------------------------------------
void mydata_write_char(char c){
  if (((mydata.tx_buffer_write+1) & (MYDATA_BUFFER_SIZE-1)) ==  mydata.tx_buffer_read){
    //Datenverlust
    usart_write("mydata_write_char:Datenverlust\r\n"); //TODO: raus!

//    mydatad_send_data (); //<<<<<<<<<<<------------- WOZU? IST DAS WIRKLICH OK?
    while(mydata.status.ack_wait)
    {
      eth_get_data();
    }
  }
  mydata.tx_buffer[mydata.tx_buffer_write] = c;
  
  mydata.tx_buffer_write = (mydata.tx_buffer_write + 1) & (MYDATA_BUFFER_SIZE-1);
  return;
}

